// generated by CommonCode.cmake, do not edit.

/**
 * @file GLStats/version.h
 * Defines version macros and class for GLStats.
 */

#ifndef GLSTATS_VERSION_H
#define GLSTATS_VERSION_H

#include <GLStats/api.h>
#include <string>

namespace GLStats
{
    /** The current major version. */
#   define GLSTATS_VERSION_MAJOR 0

    /** The current minor version. */
#   define GLSTATS_VERSION_MINOR 3

    /** The current patch level. */
#   define GLSTATS_VERSION_PATCH 1

    /** The current SCM revision. */
#   define GLSTATS_VERSION_REVISION 0x0

    /** The current binary interface. */
#   define GLSTATS_VERSION_ABI 1

/** True if the current version is newer than the given one. */
#   define GLSTATS_VERSION_GT( MAJOR, MINOR, PATCH )       \
    ( (GLSTATS_VERSION_MAJOR>MAJOR) ||                     \
      (GLSTATS_VERSION_MAJOR==MAJOR && (GLSTATS_VERSION_MINOR>MINOR || \
          (GLSTATS_VERSION_MINOR==MINOR && GLSTATS_VERSION_PATCH>PATCH))))

/** True if the current version is equal or newer to the given. */
#   define GLSTATS_VERSION_GE( MAJOR, MINOR, PATCH )       \
    ( (GLSTATS_VERSION_MAJOR>MAJOR) ||                     \
      (GLSTATS_VERSION_MAJOR==MAJOR && (GLSTATS_VERSION_MINOR>MINOR || \
          (GLSTATS_VERSION_MINOR==MINOR && GLSTATS_VERSION_PATCH>=PATCH))))

/** True if the current version is older than the given one. */
#   define GLSTATS_VERSION_LT( MAJOR, MINOR, PATCH )       \
    ( (GLSTATS_VERSION_MAJOR<MAJOR) ||                     \
      (GLSTATS_VERSION_MAJOR==MAJOR && (GLSTATS_VERSION_MINOR<MINOR || \
          (GLSTATS_VERSION_MINOR==MINOR && GLSTATS_VERSION_PATCH<PATCH))))

/** True if the current version is older or equal to the given. */
#   define GLSTATS_VERSION_LE( MAJOR, MINOR, PATCH )       \
    ( (GLSTATS_VERSION_MAJOR<MAJOR) ||                     \
      (GLSTATS_VERSION_MAJOR==MAJOR && (GLSTATS_VERSION_MINOR<MINOR || \
        (GLSTATS_VERSION_MINOR==MINOR && GLSTATS_VERSION_PATCH<=PATCH))))

/** Information about the current GLStats version. */
class GLSTATS_API Version
{
public:
    /** @return the current major version of GLStats. */
    static int getMajor();

    /** @return the current minor version of GLStats. */
    static int getMinor();

    /** @return the current patch level of GLStats. */
    static int getPatch();

    /** @return the current GLStats version (MM.mm.pp). */
    static std::string getString();

    /** @return the SCM revision. */
    static int getRevision();

    /** @return the current binary interface version of GLStats. */
    static int getABI();

    /** @return the current GLStats version plus the git SHA hash (MM.mm.pp.rev). */
    static std::string getRevString();

    /**
     * Runtime check for ABI compatibility.
     *
     * Call from code using GLStats. Will fail if the executable
     * was compiled against a version incompatible with the runtime version.
     *
     * @return true if the link-time and compile-time DSO are compatible.
     */
    static bool check()
    {
        return getMajor()==GLSTATS_VERSION_MAJOR &&
               getMinor()==GLSTATS_VERSION_MINOR;
    }
};

}

#endif
